=== test/executable_tests/Makefile ===


all: topology pin perfctr memsweeper powermeter features bench genCfg setFreq

topology:
	./tester.sh likwid-topology
pin:
	./tester.sh likwid-pin
perfctr:
	./tester.sh likwid-perfctr
memsweeper:
	./tester.sh likwid-memsweeper
powermeter:
	./tester.sh likwid-powermeter
features:
	./tester.sh likwid-features
bench:
	./tester.sh likwid-bench
genCfg:
	./tester.sh likwid-genCfg
setFreq:
	./tester.sh likwid-setFreq
