=== debian/changelog ===
likwid (3.1.3+dfsg1-1) unstable; urgency=medium

  * source repack to remove non DFSG files

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 02 Sep 2015 17:49:02 +0200

likwid (3.1.3-2) unstable; urgency=medium

  * include bstrlib license documentation
  * remove streams benchmark because of license problems

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 20 May 2015 11:35:25 +0200

likwid (3.1.3-1) unstable; urgency=medium

  * New upstream release

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 27 Apr 2015 12:32:16 +0200

likwid (3.1.2-1) experimental; urgency=low

  * Initial release. (Closes: #766474)

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 30 Oct 2014 13:23:08 +0100
