=== src/access-daemon/Makefile ===
--- 
+++ 
@@ -4,13 +4,13 @@
 #
 #      Description:  accessDaemon Makefile
 #
-#      Version:   3.1.3
-#      Released:  4.11.2014
+#      Version:   4.1
+#      Released:  19.5.2016
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #      Project:  likwid
 #
-#      Copyright (C) 2014 Jan Treibig
+#      Copyright (C) 2016 RRZE, University Erlangen-Nuremberg
 #
 #      This program is free software: you can redistribute it and/or modify it under
 #      the terms of the GNU General Public License as published by the Free Software
@@ -31,20 +31,22 @@
 
 DAEMON_TARGET = likwid-accessD
 SETFREQ_TARGET = likwid-setFreq
+Q         ?= @
 
-DEFINES   = -D_GNU_SOURCE -DMAX_NUM_THREADS=$(MAX_NUM_THREADS)
+DEFINES   += -D_GNU_SOURCE -DMAX_NUM_THREADS=$(MAX_NUM_THREADS) -DMAX_NUM_NODES=$(MAX_NUM_NODES)
 INCLUDES  = -I../includes
-ifeq ($(COMPILER),GCC)
-CFLAGS    +=  -pedantic -Wall -Wextra -std=c99
+CFLAGS    += -std=c99 -fPIC -pie -fPIE -fstack-protector
+ifeq ($(COMPILER),GCCX86)
+CFLAGS    +=  -m32
 endif
 CPPFLAGS :=  $(DEFINES) $(INCLUDES)
-Q=
 
 all: $(DAEMON_TARGET) $(SETFREQ_TARGET)
 
 $(DAEMON_TARGET): accessDaemon.c
-	$(CC) $(ANSI_CFLAGS) $(CFLAGS) $(CPPFLAGS) -o ../../$(DAEMON_TARGET) accessDaemon.c
+	$(Q)$(CC) $(CFLAGS) $(CPPFLAGS) -o ../../$(DAEMON_TARGET) accessDaemon.c
 
 $(SETFREQ_TARGET): setFreq.c
-	$(CC) $(ANSI_CFLAGS) $(CFLAGS) $(CPPFLAGS) -o ../../$(SETFREQ_TARGET) setFreq.c
+	$(Q)$(CC) $(CFLAGS) $(CPPFLAGS) -o ../../$(SETFREQ_TARGET) setFreq.c
 
+
