=== debian/changelog ===
likwid (4.1.0+dfsg1-2) unstable; urgency=medium

  [ Thomas.Roehl ]
  * Patch to remove sysctl from hwloc (closes: #827881)
  * Change architecture check to check bits instead of complete build string to select compiler

  [ Christoph Martin ]
  * fix build for i386 (closes: #797959)

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 28 Jun 2016 09:42:33 +0200

likwid (4.1.0+dfsg1-1) unstable; urgency=medium

  * update watch file for uscan
  * Imported Upstream version 4.1.0+dfsg1
  * change architecture to i386, amd64 and x32 (closes: #797959, #797960)
  * fix lintian errors (manpages etc.)
  * build against Debian lua5.2

 -- Christoph Martin <martin@uni-mainz.de>  Tue, 21 Jun 2016 19:43:36 +0200
