=== debian/control ===
--- 
+++ 
@@ -3,15 +3,15 @@
 Section: misc
 Priority: optional
 Standards-Version: 3.9.6
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), gfortran
-Homepage: http://code.google.com/p/likwid/wiki/Introduction
-Vcs-Git: git://anonscm.debian.org/likwid/likwid.git
-Vcs-Browser: http://anonscm.debian.org/cgit/likwid/likwid.git;a=summary
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), gfortran, liblua5.2-dev
+Homepage: https://github.com/rrze-likwid/likwid
+Vcs-Git: https://anonscm.debian.org/git/likwid/likwid.git
+Vcs-Browser: https://anonscm.debian.org/cgit/likwid/likwid.git
 
 Package: likwid
-Architecture: any
-Pre-Depends: multiarch-support, ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
+Architecture: amd64 i386 x32
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, lua5.2
 Description: toolsuite for performance oriented programmers
  Likwid is a simple to install and use toolsuite of command line applications
  for performance oriented programmers. It works for Intel and AMD processors
