## likwid 4.1.1

=== src/access-daemon/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 #      Description:  accessDaemon Makefile
 #
 #      Version:   4.1
-#      Released:  19.5.2016
+#      Released:  13.6.2016
 #
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
 #      Project:  likwid
