=== src/pthread-overload/Makefile ===
--- 
+++ 
@@ -1,16 +1,18 @@
 # =======================================================================================
-#  
+#
 #      Filename:  Makefile
-# 
+#
 #      Description:  pthread-overload Makefile
-# 
-#      Version:   3.1.3
-#      Released:  4.11.2014
-# 
+#
+#      Version:   4.1
+#      Released:  13.6.2016
+#
 #      Author:  Jan Treibig (jt), jan.treibig@gmail.com
+#               Thomas Roehl (tr), thomas.roehl@googlemail.com
+#
 #      Project:  likwid
 #
-#      Copyright (C) 2014 Jan Treibig
+#      Copyright (C) 2016 RRZE, University Erlangen-Nuremberg
 #
 #      This program is free software: you can redistribute it and/or modify it under
 #      the terms of the GNU General Public License as published by the Free Software
@@ -28,14 +30,17 @@
 
 include  ../../config.mk
 include  ../../make/include_$(COMPILER).mk
+include  ../../make/config_checks.mk
+include  ../../make/config_defines.mk
 
-TARGET   = liblikwidpin.so
+
+TARGET   = $(PINLIB)
 
 ifneq ($(COLOR),NONE)
 DEFINES += -DCOLOR=$(COLOR)
 endif
 
-DEFINES  += -DMAX_NUM_THREADS=$(MAX_NUM_THREADS)
+DEFINES  += -DMAX_NUM_THREADS=$(MAX_NUM_THREADS) -D_GNU_SOURCE
 INCLUDES += -I../includes
 LIBS     += -ldl
 CPPFLAGS := $(CPPFLAGS) $(DEFINES) $(INCLUDES) 
@@ -43,5 +48,5 @@
 all: $(TARGET)
 
 $(TARGET): pthread-overload.c
-	$(CC) $(CFLAGS) $(ANSI_CFLAGS) $(CPPFLAGS) $(INCLUDES) $(SHARED_CFLAGS) $(SHARED_LFLAGS) -o ../../$(TARGET) pthread-overload.c $(LIBS)
+	$(CC) -Wl,-soname,$(TARGET).$(VERSION).$(RELEASE) $(CFLAGS) $(ANSI_CFLAGS) $(CPPFLAGS) $(INCLUDES) $(SHARED_CFLAGS) $(SHARED_LFLAGS) -o ../../$(TARGET) pthread-overload.c $(LIBS)
